import sys, os, subprocess
import xml.etree.ElementTree

JAR_NAME = "xmlschemavalidator.jar"
XSD_NAME = "aoqml.xsd"

parsefolder = ""
if 2 == len(sys.argv):
   parsefolder = sys.argv[1]
else:
   print('USAGE: python checkintegrity.py FOLDER')
   sys.exit(1)

dir_path = os.path.dirname(os.path.realpath(__file__))
xsd = os.path.join(dir_path, XSD_NAME)

def checkTargetAttributes(attributes):
   target = attributes.get('target')
   foundError = False
   if target != None and target[0] != '$' and '/lib/' not in target:
      tocheck = os.path.join(folderName,target+'.xml')
      if not os.path.isfile(tocheck): 
         foundError = True
         print(fullname + ' references missing file ' + tocheck)
   return foundError


totalfilecount = 0
totalfilewitherrorscount = 0
for folderName, subfolders, filenames in os.walk(parsefolder):
   for origfilename in filenames:
      fullname = os.path.join(folderName,origfilename)
      if '.xml' in origfilename \
         and origfilename != '.aoqml-editor':
         totalfilecount += 1
         # works only at python 2.7: 
         #parse_result = subprocess.check_output( \
         #['java', '-jar', os.path.join(dir_path,JAR_NAME), \
         #xsd, fullname ])
         # reference http://stackoverflow.com/questions/4814970/subprocess-check-output-doesnt-seem-to-exist-python-2-6-5#4814985
         # for 2.6 and above:
         parse_result = subprocess.Popen( \
         ['java', '-jar', os.path.join(dir_path,JAR_NAME), \
         xsd, fullname ], stdout=subprocess.PIPE).communicate()[0]
         if parse_result:
            totalfilewitherrorscount  += 1
            print(parse_result)
         else:
            e = xml.etree.ElementTree.parse(fullname).getroot()
            error = False
            for atype in e.findall('.//choice'):
               error = error or checkTargetAttributes(atype)
            for atype in e.findall('.//take'):
               error = error or checkTargetAttributes(atype)
            for atype in e.findall('.//item-select'):
               error = error or checkTargetAttributes(atype)
            for atype in e.findall('.//include'):
               error = error or checkTargetAttributes(atype)
            if error:
               totalfilewitherrorscount  += 1

print('count of processed files: ' + str(totalfilecount))
print('count of processed files with errors: ' + str(totalfilewitherrorscount))

